// GraphicsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Graphics.h"
#include "GraphicsDlg.h"
#include ".\graphicsdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGraphicsDlg dialog



CGraphicsDlg::CGraphicsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraphicsDlg::IDD, pParent)
	, m_iTool(0)
	, m_iShape(0)
	, m_iColor(7)
	, strFileName(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraphicsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RPEN, m_iTool);
	DDX_Radio(pDX, IDC_RLINE, m_iShape);
	DDX_Radio(pDX, IDC_RBLACK, m_iColor);
}

BEGIN_MESSAGE_MAP(CGraphicsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BEXIT, OnBnClickedBexit)
	ON_BN_CLICKED(IDC_RPEN, OnRadioSelection)
	ON_BN_CLICKED(IDC_RBRUSH, OnRadioSelection)
	ON_BN_CLICKED(IDC_RBITMAP, OnRadioSelection)
	ON_BN_CLICKED(IDC_RLINE, OnRadioSelection)
	ON_BN_CLICKED(IDC_RCIRCLE, OnRadioSelection)
	ON_BN_CLICKED(IDC_RSQUARE, OnRadioSelection)
	ON_BN_CLICKED(IDC_RBLACK, OnRadioSelection)
	ON_BN_CLICKED(IDC_RBLUE, OnRadioSelection)
	ON_BN_CLICKED(IDC_RGREEN, OnRadioSelection)
	ON_BN_CLICKED(IDC_RCYAN, OnRadioSelection)
	ON_BN_CLICKED(IDC_RRED, OnRadioSelection)
	ON_BN_CLICKED(IDC_RMAGENTA, OnRadioSelection)
	ON_BN_CLICKED(IDC_RYELLOW, OnRadioSelection)
	ON_BN_CLICKED(IDC_RWHITE, OnRadioSelection)
	ON_BN_CLICKED(IDC_BBITMAP, OnBnClickedBbitmap)
END_MESSAGE_MAP()


// CGraphicsDlg message handlers

BOOL CGraphicsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//       
	m_dlgPaint.Create(IDD_PAINT_DLG, this);
	//    
	m_dlgPaint.ShowWindow(SW_SHOW);
	b_singleFlag = true;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGraphicsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGraphicsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if(b_singleFlag) //   
		OnRadioSelection();//     
	if(b_singleFlag) //  
		b_singleFlag = !b_singleFlag;
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGraphicsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CGraphicsDlg::OnBnClickedBexit()
{
	OnOK();
}

void CGraphicsDlg::OnRadioSelection()
{
	UpdateData(TRUE); //    
	m_dlgPaint.Invalidate(); //   

//    ,   !!!!!
/*	CString str;
	str.Format("Tool=%d; Shape=%d; Color=%d", m_iTool, m_iShape, m_iColor);
	MessageBox(str, " ");
*/
}

void CGraphicsDlg::OnBnClickedBbitmap()
{
	if(m_iTool != 2 || m_iShape == 0) return; 
	
	//  
		static char szFilterBmp[] = "Bitmap Files (*.bmp)|*.bmp||";
		static char szFilterDefault[] = 
			"JPEG Files (*.jpg)|*.jpg|"
			"PNG Files (*.png)|*.png|"
			"Bitmap Files (*.bmp)|*.bmp||";
		char  *filter;//  

	//  
	if(m_iShape == 1) // Circle    CBitmap
		filter = szFilterBmp;
	else //   Shape==Square
		filter = szFilterDefault;

	//     

	//     File Open
	CFileDialog dlgOpenFileDialog(TRUE, "", strFileName,
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, filter);

	//   
	if(dlgOpenFileDialog.DoModal() == IDOK){
		//        
		strFileName = dlgOpenFileDialog.GetPathName();
		m_dlgPaint.Invalidate(); //   
	}
}

